diff --git a/django/core/management/validation.py b/django/core/management/validation.py
index 56708e1..b2f7da5 100644
--- a/django/core/management/validation.py
+++ b/django/core/management/validation.py
@@ -15,6 +15,7 @@ class ModelErrorCollection:
         self.errors.append((context, error))
         self.outfile.write(self.style.ERROR("%s: %s\n" % (context, error)))
 
+
 def get_validation_errors(outfile, app=None):
     """
     Validates all models that are part of the specified app. If no app name is provided,
@@ -72,9 +73,15 @@ def get_validation_errors(outfile, app=None):
                 e.add(opts, '"%s": Field\'s name must not contain "%s".' % (
                                 f.name, LOOKUP_SEP))
             if f.name == 'id' and not f.primary_key and opts.pk.name == 'id':
-                e.add(opts, '"%s": You can\'t use "id" as a field name, because each model automatically gets an "id" field if none of the fields have primary_key=True. You need to either remove/rename your "id" field or add primary_key=True to a field.' % f.name)
+                e.add(opts, '"%s": You can\'t use "id" as a field name, because '
+                            'each model automatically gets an "id" field '
+                            'if none of the fields have primary_key=True. '
+                            'You need to either remove/rename your "id" field '
+                            'or add primary_key=True to a field.' % f.name)
             if f.name.endswith('_'):
-                e.add(opts, '"%s": Field names cannot end with underscores, because this would lead to ambiguous queryset filters.' % f.name)
+                e.add(opts, '"%s": Field names cannot end with underscores, '
+                            'because this would lead to ambiguous queryset filters.' %
+                                f.name)
             if (f.primary_key and f.null and
                     not connection.features.interprets_empty_strings_as_nulls):
                 # We cannot reliably check this for backends like Oracle which
@@ -85,12 +92,15 @@ def get_validation_errors(outfile, app=None):
                 try:
                     max_length = int(f.max_length)
                     if max_length <= 0:
-                        e.add(opts, '"%s": CharFields require a "max_length" attribute that is a positive integer.' % f.name)
+                        e.add(opts, '"%s": CharFields require a "max_length" attribute '
+                                    'that is a positive integer.' % f.name)
                 except (ValueError, TypeError):
-                    e.add(opts, '"%s": CharFields require a "max_length" attribute that is a positive integer.' % f.name)
+                    e.add(opts, '"%s": CharFields require a "max_length" attribute '
+                                'that is a positive integer.' % f.name)
             if isinstance(f, models.DecimalField):
                 decimalp_ok, mdigits_ok = False, False
-                decimalp_msg ='"%s": DecimalFields require a "decimal_places" attribute that is a non-negative integer.'
+                decimalp_msg = ('"%s": DecimalFields require a "decimal_places" attribute '
+                                'that is a non-negative integer.')
                 try:
                     decimal_places = int(f.decimal_places)
                     if decimal_places < 0:
@@ -99,7 +109,8 @@ def get_validation_errors(outfile, app=None):
                         decimalp_ok = True
                 except (ValueError, TypeError):
                     e.add(opts, decimalp_msg % f.name)
-                mdigits_msg = '"%s": DecimalFields require a "max_digits" attribute that is a positive integer.'
+                mdigits_msg = ('"%s": DecimalFields require a "max_digits" attribute '
+                               'that is a positive integer.')
                 try:
                     max_digits = int(f.max_digits)
                     if max_digits <= 0:
@@ -108,7 +119,9 @@ def get_validation_errors(outfile, app=None):
                         mdigits_ok = True
                 except (ValueError, TypeError):
                     e.add(opts, mdigits_msg % f.name)
-                invalid_values_msg = '"%s": DecimalFields require a "max_digits" attribute value that is greater than or equal to the value of the "decimal_places" attribute.'
+                invalid_values_msg = ('"%s": DecimalFields require a "max_digits" '
+                                      'attribute value that is greater than or equal to '
+                                      'the value of the "decimal_places" attribute.')
                 if decimalp_ok and mdigits_ok:
                     if decimal_places > max_digits:
                         e.add(opts, invalid_values_msg % f.name)
@@ -122,12 +135,16 @@ def get_validation_errors(outfile, app=None):
                     try:
                         import Image
                     except ImportError:
-                        e.add(opts, '"%s": To use ImageFields, you need to install the Python Imaging Library. Get it at http://www.pythonware.com/products/pil/ .' % f.name)
+                        e.add(opts, '"%s": To use ImageFields, you need to install '
+                                    'the Python Imaging Library. Get it '
+                                    'at http://www.pythonware.com/products/pil/ .' % f.name)
             if isinstance(f, models.BooleanField) and getattr(f, 'null', False):
-                e.add(opts, '"%s": BooleanFields do not accept null values. Use a NullBooleanField instead.' % f.name)
+                e.add(opts, '"%s": BooleanFields do not accept null values. '
+                            'Use a NullBooleanField instead.' % f.name)
             if f.choices:
                 if isinstance(f.choices, basestring) or not is_iterable(f.choices):
-                    e.add(opts, '"%s": "choices" should be iterable (e.g., a tuple or list).' % f.name)
+                    e.add(opts, '"%s": "choices" should be iterable '
+                                '(e.g., a tuple or list).' % f.name)
                 else:
                     for c in f.choices:
                         if not isinstance(c, (list, tuple)) or len(c) != 2:
@@ -141,15 +158,19 @@ def get_validation_errors(outfile, app=None):
             # Check if the on_delete behavior is sane
             if f.rel and hasattr(f.rel, 'on_delete'):
                 if f.rel.on_delete == SET_NULL and not f.null:
-                    e.add(opts, "'%s' specifies on_delete=SET_NULL, but cannot be null." % f.name)
+                    e.add(opts, "'%s' specifies on_delete=SET_NULL, "
+                                "but cannot be null." % f.name)
                 elif f.rel.on_delete == SET_DEFAULT and not f.has_default():
-                    e.add(opts, "'%s' specifies on_delete=SET_DEFAULT, but has no default value." % f.name)
+                    e.add(opts, "'%s' specifies on_delete=SET_DEFAULT, "
+                                "but has no default value." % f.name)
 
-            # Check to see if the related field will clash with any existing
+            # Check to see if the related field will clashing_field with any existing
             # fields, m2m fields, m2m related objects or related objects
             if f.rel:
                 if f.rel.to not in models.get_models():
-                    e.add(opts, "'%s' has a relation with model %s, which has either not been installed or is abstract." % (f.name, f.rel.to))
+                    e.add(opts, "'%s' has a relation with model %s, "
+                                "which has either not been installed or is abstract." % (
+                                    f.name, f.rel.to))
                 # it is a string and we could not find the model it refers to
                 # so skip the next section
                 if isinstance(f.rel.to, (str, unicode)):
@@ -157,7 +178,9 @@ def get_validation_errors(outfile, app=None):
 
                 # Make sure the related field specified by a ForeignKey is unique
                 if not f.rel.to._meta.get_field(f.rel.field_name).unique:
-                    e.add(opts, "Field '%s' under model '%s' must have a unique=True constraint." % (f.rel.field_name, f.rel.to.__name__))
+                    e.add(opts, "Field '%s' under model '%s' must have "
+                                "a unique=True constraint." % (
+                                    f.rel.field_name, f.rel.to.__name__))
 
                 rel_opts = f.rel.to._meta
                 rel_name = RelatedObject(f.rel.to, cls, f).get_accessor_name()
@@ -165,33 +188,67 @@ def get_validation_errors(outfile, app=None):
                 if not f.rel.is_hidden():
                     for r in rel_opts.fields:
                         if r.name == rel_name:
-                            e.add(opts, "Accessor for field '%s' clashes with field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                            e.add(opts, "Accessor for field '%s' clashes "
+                                        "with field '%s.%s'. Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name, r.name, f.name))
                         if r.name == rel_query_name:
-                            e.add(opts, "Reverse query name for field '%s' clashes with field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                            e.add(opts, "Reverse query name for field '%s' "
+                                        "clashes with field '%s.%s'. "
+                                        "Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name, r.name, f.name))
                     for r in rel_opts.local_many_to_many:
                         if r.name == rel_name:
-                            e.add(opts, "Accessor for field '%s' clashes with m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                            e.add(opts, "Accessor for field '%s' clashes "
+                                        "with m2m field '%s.%s'. Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name, r.name, f.name))
                         if r.name == rel_query_name:
-                            e.add(opts, "Reverse query name for field '%s' clashes with m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                            e.add(opts, "Reverse query name for field '%s' clashes "
+                                        "with m2m field '%s.%s'. Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name, r.name, f.name))
                     for r in rel_opts.get_all_related_many_to_many_objects():
                         if r.get_accessor_name() == rel_name:
-                            e.add(opts, "Accessor for field '%s' clashes with related m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                            e.add(opts, "Accessor for field '%s' clashes "
+                                        "with related m2m field '%s.%s'. "
+                                        "Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
                         if r.get_accessor_name() == rel_query_name:
-                            e.add(opts, "Reverse query name for field '%s' clashes with related m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                            e.add(opts, "Reverse query name for field '%s' clashes "
+                                        "with related m2m field '%s.%s'. "
+                                        "Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name,
+                                            r.get_accessor_name(), f.name))
                     for r in rel_opts.get_all_related_objects():
                         if r.field is not f:
                             if r.get_accessor_name() == rel_name:
-                                e.add(opts, "Accessor for field '%s' clashes with related field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                                e.add(opts, "Accessor for field '%s' clashes "
+                                            "with related field '%s.%s'. "
+                                            "Add a related_name argument "
+                                            "to the definition for '%s'." % (
+                                                f.name, rel_opts.object_name,
+                                                r.get_accessor_name(), f.name))
                             if r.get_accessor_name() == rel_query_name:
-                                e.add(opts, "Reverse query name for field '%s' clashes with related field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                                e.add(opts, "Reverse query name for field '%s' "
+                                            "clashes with related field '%s.%s'. "
+                                            "Add a related_name argument "
+                                            "to the definition for '%s'." % (
+                                                f.name, rel_opts.object_name,
+                                                r.get_accessor_name(), f.name))
 
         seen_intermediary_signatures = []
         for i, f in enumerate(opts.local_many_to_many):
-            # Check to see if the related m2m field will clash with any
+            # Check to see if the related m2m field will clashing_field with any
             # existing fields, m2m fields, m2m related objects or related
             # objects
             if f.rel.to not in models.get_models():
-                e.add(opts, "'%s' has an m2m relation with model %s, which has either not been installed or is abstract." % (f.name, f.rel.to))
+                e.add(opts, "'%s' has an m2m relation with model %s, "
+                            "which has either not been installed or is abstract." % (
+                                f.name, f.rel.to))
                 # it is a string and we could not find the model it refers to
                 # so skip the next section
                 if isinstance(f.rel.to, (str, unicode)):
@@ -199,12 +256,16 @@ def get_validation_errors(outfile, app=None):
 
             # Check that the field is not set to unique.  ManyToManyFields do not support unique.
             if f.unique:
-                e.add(opts, "ManyToManyFields cannot be unique.  Remove the unique argument on '%s'." % f.name)
+                e.add(opts, "ManyToManyFields cannot be unique.  "
+                            "Remove the unique argument on '%s'." % f.name)
 
             if f.rel.through is not None and not isinstance(f.rel.through, basestring):
                 from_model, to_model = cls, f.rel.to
-                if from_model == to_model and f.rel.symmetrical and not f.rel.through._meta.auto_created:
-                    e.add(opts, "Many-to-many fields with intermediate tables cannot be symmetrical.")
+                if (from_model == to_model and
+                    f.rel.symmetrical and
+                    not f.rel.through._meta.auto_created):
+                    e.add(opts, "Many-to-many fields with intermediate tables "
+                                "cannot be symmetrical.")
                 seen_from, seen_to, seen_self = False, False, 0
                 for inter_field in f.rel.through._meta.fields:
                     rel_to = getattr(inter_field.rel, 'to', None)
@@ -213,49 +274,41 @@ def get_validation_errors(outfile, app=None):
                             seen_self += 1
                         if seen_self > 2:
                             e.add(opts, "Intermediary model %s has more than "
-                                "two foreign keys to %s, which is ambiguous "
-                                "and is not permitted." % (
-                                    f.rel.through._meta.object_name,
-                                    from_model._meta.object_name
-                                )
-                            )
+                                        "two foreign keys to %s, which is ambiguous "
+                                        "and is not permitted." % (
+                                            f.rel.through._meta.object_name,
+                                            from_model._meta.object_name))
                     else:
                         if rel_to == from_model:
                             if seen_from:
                                 e.add(opts, "Intermediary model %s has more "
-                                    "than one foreign key to %s, which is "
-                                    "ambiguous and is not permitted." % (
-                                        f.rel.through._meta.object_name,
-                                         from_model._meta.object_name
-                                     )
-                                 )
+                                            "than one foreign key to %s, which is "
+                                            "ambiguous and is not permitted." % (
+                                                f.rel.through._meta.object_name,
+                                                from_model._meta.object_name))
                             else:
                                 seen_from = True
                         elif rel_to == to_model:
                             if seen_to:
                                 e.add(opts, "Intermediary model %s has more "
-                                    "than one foreign key to %s, which is "
-                                    "ambiguous and is not permitted." % (
-                                        f.rel.through._meta.object_name,
-                                        rel_to._meta.object_name
-                                    )
-                                )
+                                            "than one foreign key to %s, which is "
+                                            "ambiguous and is not permitted." % (
+                                                f.rel.through._meta.object_name,
+                                                rel_to._meta.object_name))
                             else:
                                 seen_to = True
                 if f.rel.through not in models.get_models(include_auto_created=True):
                     e.add(opts, "'%s' specifies an m2m relation through model "
-                        "%s, which has not been installed." % (f.name, f.rel.through)
-                    )
+                                "%s, which has not been installed." % (
+                                    f.name, f.rel.through))
                 signature = (f.rel.to, cls, f.rel.through)
                 if signature in seen_intermediary_signatures:
                     e.add(opts, "The model %s has two manually-defined m2m "
-                        "relations through the model %s, which is not "
-                        "permitted. Please consider using an extra field on "
-                        "your intermediary model instead." % (
-                            cls._meta.object_name,
-                            f.rel.through._meta.object_name
-                        )
-                    )
+                                "relations through the model %s, which is not "
+                                "permitted. Please consider using an extra field on "
+                                "your intermediary model instead." % (
+                                    cls._meta.object_name,
+                                    f.rel.through._meta.object_name))
                 else:
                     seen_intermediary_signatures.append(signature)
                 if not f.rel.through._meta.auto_created:
@@ -268,14 +321,13 @@ def get_validation_errors(outfile, app=None):
                                 seen_this_fk = True
                     if not seen_related_fk or not seen_this_fk:
                         e.add(opts, "'%s' is a manually-defined m2m relation "
-                            "through model %s, which does not have foreign keys "
-                            "to %s and %s" % (f.name, f.rel.through._meta.object_name,
-                                f.rel.to._meta.object_name, cls._meta.object_name)
-                        )
+                                    "through model %s, which does not have foreign keys "
+                                    "to %s and %s" % (
+                                        f.name, f.rel.through._meta.object_name,
+                                        f.rel.to._meta.object_name, cls._meta.object_name))
             elif isinstance(f.rel.through, basestring):
                 e.add(opts, "'%s' specifies an m2m relation through model %s, "
-                    "which has not been installed" % (f.name, f.rel.through)
-                )
+                            "which has not been installed" % (f.name, f.rel.through))
 
             rel_opts = f.rel.to._meta
             rel_name = RelatedObject(f.rel.to, cls, f).get_accessor_name()
@@ -287,25 +339,62 @@ def get_validation_errors(outfile, app=None):
             if rel_name is not None:
                 for r in rel_opts.fields:
                     if r.name == rel_name:
-                        e.add(opts, "Accessor for m2m field '%s' clashes with field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                        e.add(opts, "Accessor for m2m field '%s' clashes "
+                                    "with field '%s.%s'. Add a related_name "
+                                    "argument to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name, r.name, f.name))
                     if r.name == rel_query_name:
-                        e.add(opts, "Reverse query name for m2m field '%s' clashes with field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                        e.add(opts, "Reverse query name for m2m field '%s' "
+                                    "clashes with field '%s.%s'. "
+                                    "Add a related_name argument "
+                                    "to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name,
+                                        r.name, f.name))
                 for r in rel_opts.local_many_to_many:
                     if r.name == rel_name:
-                        e.add(opts, "Accessor for m2m field '%s' clashes with m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                        e.add(opts, "Accessor for m2m field '%s' clashes "
+                                    "with m2m field '%s.%s'. Add a related_name "
+                                    "argument to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name,
+                                        r.name, f.name))
                     if r.name == rel_query_name:
-                        e.add(opts, "Reverse query name for m2m field '%s' clashes with m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.name, f.name))
+                        e.add(opts, "Reverse query name for m2m field '%s' "
+                                    "clashes with m2m field '%s.%s'. "
+                                    "Add a related_name argument "
+                                    "to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name,
+                                        r.name, f.name))
                 for r in rel_opts.get_all_related_many_to_many_objects():
                     if r.field is not f:
                         if r.get_accessor_name() == rel_name:
-                            e.add(opts, "Accessor for m2m field '%s' clashes with related m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                            e.add(opts, "Accessor for m2m field '%s' clashes "
+                                        "with related m2m field '%s.%s'. "
+                                        "Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name,
+                                            r.get_accessor_name(), f.name))
                         if r.get_accessor_name() == rel_query_name:
-                            e.add(opts, "Reverse query name for m2m field '%s' clashes with related m2m field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                            e.add(opts, "Reverse query name for m2m field '%s' "
+                                        "clashes with related m2m field '%s.%s'. "
+                                        "Add a related_name argument "
+                                        "to the definition for '%s'." % (
+                                            f.name, rel_opts.object_name,
+                                            r.get_accessor_name(), f.name))
                 for r in rel_opts.get_all_related_objects():
                     if r.get_accessor_name() == rel_name:
-                        e.add(opts, "Accessor for m2m field '%s' clashes with related field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                        e.add(opts, "Accessor for m2m field '%s' clashes "
+                                    "with related field '%s.%s'. "
+                                    "Add a related_name argument "
+                                    "to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name,
+                                        r.get_accessor_name(), f.name))
                     if r.get_accessor_name() == rel_query_name:
-                        e.add(opts, "Reverse query name for m2m field '%s' clashes with related field '%s.%s'. Add a related_name argument to the definition for '%s'." % (f.name, rel_opts.object_name, r.get_accessor_name(), f.name))
+                        e.add(opts, "Reverse query name for m2m field '%s' "
+                                    "clashes with related field '%s.%s'. "
+                                    "Add a related_name argument "
+                                    "to the definition for '%s'." % (
+                                        f.name, rel_opts.object_name,
+                                        r.get_accessor_name(), f.name))
 
         # Check ordering attribute.
         if opts.ordering:
@@ -327,7 +416,8 @@ def get_validation_errors(outfile, app=None):
                 try:
                     opts.get_field(field_name, many_to_many=False)
                 except models.FieldDoesNotExist:
-                    e.add(opts, '"ordering" refers to "%s", a field that doesn\'t exist.' % field_name)
+                    e.add(opts, '"ordering" refers to "%s", '
+                                'a field that doesn\'t exist.' % field_name)
 
         # Check unique_together.
         for ut in opts.unique_together:
@@ -335,11 +425,17 @@ def get_validation_errors(outfile, app=None):
                 try:
                     f = opts.get_field(field_name, many_to_many=True)
                 except models.FieldDoesNotExist:
-                    e.add(opts, '"unique_together" refers to %s, a field that doesn\'t exist. Check your syntax.' % field_name)
+                    e.add(opts, '"unique_together" refers to %s, '
+                                'a field that doesn\'t exist. '
+                                'Check your syntax.' % field_name)
                 else:
                     if isinstance(f.rel, models.ManyToManyRel):
-                        e.add(opts, '"unique_together" refers to %s. ManyToManyFields are not supported in unique_together.' % f.name)
+                        e.add(opts, '"unique_together" refers to %s. '
+                                    'ManyToManyFields are not supported '
+                                    'in unique_together.' % f.name)
                     if f not in opts.local_fields:
-                        e.add(opts, '"unique_together" refers to %s. This is not in the same model as the unique_together statement.' % f.name)
+                        e.add(opts, '"unique_together" refers to %s. '
+                                    'This is not in the same model '
+                                    'as the unique_together statement.' % f.name)
 
     return len(e.errors)